#
# $Id: mcPrinterInfo.pm,v 1.3 2002/03/16 01:34:27 mcooper Exp $
#
# PrinterInfo object
#

package mcPrinterInfo;
require 5.003;

use mcMisc;

my $Descriptions =
	{
	 'Name'			=> {Desc=>'Queue Name' },
	 'Aliases'		=> {Desc=>'Queue Aliases' },
	 'Descript'		=> {Desc=>'Description'},
	 'Vendor'		=> {Desc=>'Vendor'},
	 'Model'		=> {Desc=>'Model'},
	 'Proto'		=> {Desc=>'Protocol'},
	 'Device'		=> {Desc=>'Device'},
	 'Server'		=> {Desc=>'Server'},
	 'RemoteQueue'		=> {Desc=>'Remote Queue'},
	 'Langs'		=> {Desc=>'Languages'},
	 'SpoolDir'		=> {Desc=>'Spool Directory'},
	 'MaxJobSize'		=> {Desc=>'Max Job Size'},
	 'DescList'		=> {NoShow=>1},
	};
#
# Object Constructor
#
sub New {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self = {};
    my $Err;
    $self->{"Name"} = undef;
    $self->{"Aliases"} = [];
    $self->{"Descript"} = undef;
    $self->{"Vendor"} = undef;
    $self->{"Model"} = undef;
    $self->{"Proto"} = undef;
    $self->{"Device"} = undef;
    $self->{"Server"} = undef;
    $self->{"RemoteQueue"} = undef;
    $self->{"Langs"} = [];
    $self->{"SpoolDir"} = undef;
    $self->{"MaxJobSize"} = undef;
    $self->{"DescList"} = [];

    $self->{"Desc"} = undef;

    bless ($self, $class);

    return $self;
}

sub Name {
    my $self = shift;

    if (!@_) {
	return $self->{"Name"};
    }

    $self->{"Name"} = shift;

    return;
}

sub Descript {
    my $self = shift;

    if (!@_) {
	return $self->{"Descript"};
    }

    $self->{"Descript"} = shift;

    return;
}

sub Vendor {
    my $self = shift;

    if (!@_) {
	return $self->{"Vendor"};
    }

    $self->{"Vendor"} = shift;

    return;
}

sub Model {
    my $self = shift;

    if (!@_) {
	return $self->{"Model"};
    }

    $self->{"Model"} = shift;

    return;
}

sub Proto {
    my $self = shift;

    if (!@_) {
	return $self->{"Proto"};
    }

    $self->{"Proto"} = shift;

    return;
}

sub Device {
    my $self = shift;

    if (!@_) {
	return $self->{"Device"};
    }

    $self->{"Device"} = shift;

    return;
}

sub Server {
    my $self = shift;

    if (!@_) {
	return $self->{"Server"};
    }

    $self->{"Server"} = shift;

    return;
}

sub RemoteQueue {
    my $self = shift;

    if (!@_) {
	return $self->{"RemoteQueue"};
    }

    $self->{"RemoteQueue"} = shift;

    return;
}

sub SpoolDir {
    my $self = shift;

    if (!@_) {
	return $self->{"SpoolDir"};
    }

    $self->{"SpoolDir"} = shift;

    return;
}

sub MaxJobSize {
    my $self = shift;

    if (!@_) {
	return $self->{"MaxJobSize"};
    }

    $self->{"MaxJobSize"} = shift;

    return;
}

sub StartSect {
    my $self = shift;

    if (!@_) {
	return $self->{"StartSect"};
    }

    $self->{"StartSect"} = shift;

    return;
}

sub EndSect {
    my $self = shift;

    if (!@_) {
	return $self->{"EndSect"};
    }

    $self->{"EndSect"} = shift;

    return;
}

sub NumSect {
    my $self = shift;

    if (!@_) {
	return $self->{"NumSect"};
    }

    $self->{"NumSect"} = shift;

    return;
}

sub Aliases {
    my $self = shift;

    if (!@_) {
	return @{ $self->{"Aliases"} };
    }

    @{ $self->{"Aliases"} } = @_;

    return;
}

sub Langs {
    my $self = shift;

    if (!@_) {
	return @{ $self->{"Langs"} };
    }

    @{ $self->{"Langs"} } = @_;

    return;
}

sub DescList {
    my $self = shift;

    if (!@_) {
	return @{ $self->{"DescList"} };
    }

    @{ $self->{"DescList"} } = @_;

    return;
}

#
# Fetch description
#
sub Desc {
    my $self = shift;
    my $Key = shift;

    if ($Descriptions->{$Key}->{'NoShow'}) {
	return;
    }

    return $Descriptions->{$Key}->{'Desc'};
}

#
# Decode an array of general fields
#
sub Decode {
    my $self = shift;
    my @Fields = @_;

    if (Eq($Fields[1], 'name')) {
	$self->Name($Fields[2]);
	$self->Aliases(split(',',$Fields[3]));
	$self->Descript($Fields[4]);
	$self->Vendor($Fields[5]);
	$self->Model($Fields[6]);
	$self->Proto($Fields[7]);
	$self->Device($Fields[8]);
	$self->Server($Fields[9]);
	$self->RemoteQueue($Fields[10]);
	$self->Langs(split(',', $Fields[11]));
	$self->SpoolDir($Fields[12]);
	$self->MaxJobSize($Fields[13]);
    } elsif (Eq($Fields[1], 'desc')) {
	$self->Name($Fields[2]);
	push(@{ $self->DescList }, $Fields[3] => $Fields[4]);
    }

    return $self;
}

1; # Make require/use happy
