#
# $Id: mcSoftware.pm,v 1.3 2001/05/18 23:19:38 mcooper Exp $
#
# Software object
#

package mcSoftware;
require 5.003;

use mcMisc;
use mcSoftInfo;

#
# Object Constructor
#
sub New {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self = {};
    my $Err;

    $self->{"Entries"} = undef;

    bless ($self, $class);

    return $self;
}

sub Entries {
    my $self = shift;
    my $New;

    for my $Arg (@_) {
	if (ref($Arg) eq 'HASH') {
	    $New = $Arg;
	} else {
	    # Lookup and return result
	    return $self->{"Entries"}->{$Arg};
	}
    }

    if (!@_) {
	return $self->{"Entries"};
    }

    my $h = $self->{"Entries"};
    my @NewKey = keys %$New;
    my $NewVal = $New->{$NewKey[0]};
    $h->{$NewKey[0]} = $NewVal; # Overwrite old value
    $self->{"Entries"} = $h;

    return;
}

#
# Decode an array of general fields
#
sub Decode {
    my $self = shift;
    my @Fields = @_;

    if (!Eq($Fields[0], "software")) {
	return;
    }

    my $Name = $Fields[4];
    my $SoftInfo = mcSoftInfo->New;
    # Lookup the SoftInfo entry (if any)
    my $Use = $self->Entries($Name);
    if (!$Use) {
	# Need a new object
	$Use = $SoftInfo;
    }
    # Decode and Set
    $Use->Decode(@Fields);
    # Add it back
    $self->Entries({$Name => $Use});

    return $self;
}

1; # Make require/use happy
